
%global _product_name oVirt Node Next
%global _product_id ovirt-node-ng

%global	_node_image_dir /usr/share/%{name}/image/
%global	_node_image_file %{_node_image_dir}/%{name}--.squashfs.img
%global	_node_tools_dir /usr/share/%{name}/tools/

%global with_image 0
%global with_docs 0
%global with_tools 0

%if 0%{?fedora} || 0%{?rhel} >= 8
%global with_python3 1
%else
%global with_python3 0
%endif

%if 0%{?rhel} >= 8
%global with_python2 0
%else
%global with_python2 1
%endif

%global _configure ../configure

# Disable compression, because the image is already compressed
%define _source_payload w0.xzdio
%define _binary_payload w0.xzdio

Name:       %{_product_id}
Version:    4.3.6
Release:    0.20190820.0%{?dist}%{?extra_release}
License:    GPLv2
Summary:    %{_product_name}

URL:        http://www.ovirt.org/node/
Source0:    %{name}-4.3.6.tar.xz
%if 0%{?with_image}
Source1:    ovirt-node-ng-image.squashfs.img
Source2:    product.img
%endif
BuildArch:  noarch

BuildRequires: autoconf
BuildRequires: automake

%if 0%{?with_python3}
BuildRequires: python%{python3_pkgversion}-devel
%endif # with_python3

%if 0%{?with_python2}
BuildRequires: python-devel
%endif # with_python2

%description
This package provides some tooling around building %{_product_name}.
Currently the main package is empty.

%if 0%{?with_image}
# IMPORTANT
# The image and image-updat version and release are inherited
# from the ovirt-node-ng-image-update-placeholder package
# There is a lot of fu to support this.
%package image-update
Summary:    %{_product_name} Image Update
Version:    
Release:    
Requires:   imgbased >= 0.7.2

Obsoletes:  %{_product_id}-image-update-placeholder < %{version}-%{release}
Provides:  %{_product_id}-image-update-placeholder = %{version}-%{release}
Obsoletes:  %{_product_id}-image < %{version}-%{release}
Provides:   %{_product_id}-image = %{version}-%{release}

%description image-update
This package will update an %{_product_name} host with the new image.
%endif

%if 0%{?with_docs}
%package docs
Summary:     Documentation for %{_product_name}

%description docs
Subpackage for docs related to %{_product_name}
%endif

%if 0%{?with_tools}
%package tools
Summary:     Tools for %{_product_name}

%description tools
Subpackage for tools related to %{_product_name}
%endif

%package nodectl
Summary:     nodectl for %{name}
Requires:    imgbased
%if 0%{?with_python3}
Requires:   python%{python3_pkgversion}-%{name}-nodectl
%else
Requires:   python2-%{name}-nodectl
%endif # with_python3

%description nodectl
Subpackage for nodectl for %{name}


%if 0%{?with_python2}
%package -n python2-%{name}-nodectl
Summary: A python 2 module for nodectl
Requires:   %{name}-nodectl = 4.3.6

%description -n python2-%{name}-nodectl
python2-%{name}-nodectl is a python 2 library for nodectl
%endif # with_python2

%if 0%{?with_python3}
%package -n python%{python3_pkgversion}-%{name}-nodectl
Summary: A python 3 module for nodectl
Requires:   %{name}-nodectl = 4.3.6

%description -n python%{python3_pkgversion}-%{name}-nodectl
python%{python3_pkgversion}-%{name}-nodectl is a python 3 library for nodectl
%endif # with_python2

%prep
%setup -q -n %{name}-4.3.6

%build
%if 0%{?with_python2}
mkdir py2 && pushd py2
%configure PYTHON="%{__python2}"
make %{?_smp_mflags}
popd
%endif # with_python2

%if 0%{?with_python3}
mkdir py3 && pushd py3
%configure PYTHON="%{__python3}"
make %{?_smp_mflags}
%endif # with_python3


%install
install -Dm 0755 scripts/nodectl-motd.sh %{buildroot}%{_sysconfdir}/profile.d/nodectl-motd.sh
install -Dm 0755 scripts/nodectl-run-banner.sh %{buildroot}%{_sysconfdir}/profile.d/nodectl-run-banner.sh

%if 0%{?with_python2}
make -C py2 install DESTDIR="%{buildroot}"
%endif # with_python2

%if 0%{?with_python3}
make -C py3 install DESTDIR="%{buildroot}"
%endif # with_python3


%if 0%{?with_image}
# Install the image
/usr/bin/install -d %{buildroot}/%{_node_image_dir}
/usr/bin/install -m 644 %{SOURCE1} %{buildroot}/%{_node_image_file}
/usr/bin/install -m 644 %{SOURCE2} %{buildroot}/%{_node_image_dir}/product.img

%pre image-update
local_sds=($(find / -xdev -name "__DIRECT_IO_TEST__"))

if [ "$local_sds" ]; then
    echo "Local storage domains were found on the same filesystem as / ! Please migrate the data to a new LV before upgrading, or you will lose the VMs"
    echo "See: https://bugzilla.redhat.com/show_bug.cgi?id=1550205#c3"
    echo "Storage domains were found in:"
    for sd in "${local_sds[@]}"; do
        echo -e "\t$(dirname $sd)"
    done
    exit 1
fi

%post image-update
set -e
# Some magic to ensure that imgbase from
# the new image is used for updates
export MNTDIR="$(mktemp -d)"
mount "%{_node_image_file}" "$MNTDIR"
mount "$MNTDIR"/LiveOS/rootfs.img "$MNTDIR"
export PYTHONPATH="$MNTDIR"/usr/lib/python2.7/site-packages/:$PYTHONPATH
imgbase --debug update --format liveimg %{_node_image_file} >> /tmp/imgbased.log 2>&1
VOL=$(imgbase layer --volume-path $(imgbase layer --latest))
umount "$MNTDIR"
umount "$MNTDIR"

UPDATERPM="/tmp/updaterpm.path"
lsof | grep image-update | awk '{print $9}' > $UPDATERPM

UPDATELOG="/tmp/image-update.log"
echo "List of open files:" > $UPDATELOG
lsof > $UPDATELOG

mount "$VOL" "$MNTDIR"
rpm -Uvh --quiet --justdb --root "${MNTDIR}" $(cat ${UPDATERPM}) > /dev/null 2>&1
RC=$?
umount "${MNTDIR}"

rm "${UPDATERPM}"
[ $RC = 0 ] && rm "${UPDATELOG}"
rmdir "${MNTDIR}"


%files image-update
%dir %{_node_image_dir}
%{_node_image_file}
%{_node_image_dir}/product.img
%endif

%files nodectl
%{_mandir}/man8/nodectl.8.gz
%{_sysconfdir}/profile.d/nodectl-motd.sh
%{_sysconfdir}/profile.d/nodectl-run-banner.sh
%{_sbindir}/nodectl

%if 0%{?with_python2}
%files -n python2-%{name}-nodectl
%{python2_sitelib}/nodectl
%endif

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-%{name}-nodectl
%{python3_sitelib}/nodectl
%endif

%if 0%{?with_docs}
%files docs
%{_docdir}/%{name}/*
%else
%exclude %{_docdir}/%{name}/*
%endif

%if 0%{?with_tools}
%files tools
%dir %{_node_tools_dir}
%{_node_tools_dir}/*
%{_bindir}/create-node-installation-iso
%else
%exclude %{_node_tools_dir}/*
%exclude %{_bindir}/create-node-installation-iso
%endif

%changelog
* Wed Sep 7 2016 Ryan Barry <rbarry@redhat.com>
- Rename nodectl to ovirt-node-ng-nodectl
* Sat Jul 9 2016 Ryan Barry <rbarry@redhat.com>
- Add nodectl
* Mon Jan 25 2016 Douglas Schilling Landgraf <dougsland@redhat.com>
- Initial build
